#include<Ice/Ice.h>
#include<printer.h>

using namespace std;
using namespace Demo;
using namespace face1;

/*Default face server*/
class PrinterI: public Printer
{
	 public:
		     void printstring(const string &s1,string &s2,const ::Ice::Current&);
};

void PrinterI::printstring(const string &s1,string &s2,const ::Ice::Current&)
{
	 cout<<s1<<endl;
	  s2="FROM SERVER";
}

/*2nd facet servent*/
class DisplayI:public Display
{
	public:
		void Disp(const string &s1,const ::Ice::Current&);
};

void DisplayI::Disp(const string &s1,const ::Ice::Current&)
{
	cout<<s1<<endl;
}

int main(int argc,char* argv[])
{
   int status = 0;
   Ice::CommunicatorPtr ic;
   ic = Ice::initialize(argc,argv);
   Ice::ObjectAdapterPtr adapter
       = ic->createObjectAdapterWithEndpoints(
             "SimplePrinterAdapter","tcp -h 192.168.147.202 -p 10000");
   try{
   // Ice::ObjectPtr object = new PrinterI;
   PrinterPtr printer = new PrinterI();
   DisplayPtr display = new DisplayI();
   /*adapter->add(printer,Ice::stringToIdentity("SimplePrinter"));*/
   
   //PrinterPrx printerprx = adapter->addWithUUID(printer);
   Ice::ObjectPrx  printprx = adapter->addWithUUID(printer);
  // adapter->add(printer,Ice::stringToIdentity("SimplePrinter")); 
   adapter->addFacet(display,printprx->ice_getIdentity(),"Display");
   adapter->activate();
   ic->waitForShutdown();
   }
   catch(const Ice::Exception& e)
   {
	   cerr<<e<<endl;
	   status=1;
   }
   if (ic)
    {
       ic->destroy();
    }
   return status;
}

